 

import unit4.collectionsLib.*;

public class Folder 
{
	private String name;
	private Map<File> files;
	private Map<Folder> folders;
	
	public Folder(String dirName)
	{
		this.name = dirName;
		this.files = new Map<File>();
		this.folders = new Map<Folder>();
	}
	
	public File[] getAllFiles()
	{
		File[] allFiles = new File[this.files.getAllKeys().length];
		
		String[] files = this.files.getAllKeys();
		for (int i = 0; i < files.length; i++) 
			allFiles[i] = this.files.getValue(files[i]);

		return(allFiles);
	}
	
	public Folder[] getAllSubFolders()
	{
		Folder[] allSubFolders = new Folder[this.folders.getAllKeys().length];
		
		String[] folders = this.folders.getAllKeys();
		for (int i = 0; i < folders.length; i++) 
			allSubFolders[i] = this.folders.getValue(folders[i]);

		return(allSubFolders);
	}
	
	public void addFile(File file)
	{
		this.files.insert(file.getName(), file);
	}
	
	public Folder createEmptySubFolder(String folderName)
	{
		Folder folder = new Folder(folderName);
		this.folders.insert(folderName, folder);
		
		return(folder);
	}
	
	public String getName() 
	{
		return(this.name);
	}

	public String toString()
	{
		String str = "";
		String[] files = this.files.getAllKeys();
		String[] subFolders = this.folders.getAllKeys();

		str = this.name + " Content:\n";	
		for(int i=0; i<subFolders.length; i++)
		{
			Folder folder = this.folders.getValue(subFolders[i]);
			str = str + folder.name + "\t\t" + "Folder" + "\n";
		}
		
		for(int i=0; i<files.length; i++)
		{
			File file = this.files.getValue(files[i]);
			str = str + file.getName() + "\t\t" + "File" + "\t" + file.getSize() + "\n";
		}
		return(str);
	}
}
